<!DOCTYPE html>
<html>
<head>
<meta charset="UTF-8">
<title>documentation/info_segments/hunt_dec.gi.info</title>
<meta name="Generator" content="Vim/9.1">
<meta name="plugin-version" content="vim9.0_v2">
<meta name="syntax" content="none">
<meta name="settings" content="number_lines,use_css,no_foldcolumn,expand_tabs,line_ids,pre_wrap,prevent_copy=,use_input_for_pc=none">
<meta name="colorscheme" content="PaperColor">
<style>
<!--
pre { white-space: pre-wrap; font-family: monospace; color: #d0d0d0; background-color: #000000; }
body { font-family: monospace; color: #d0d0d0; background-color: #000000; }
* { font-size: 1em; }
.textRainbow_lv0_p0 { color: #add8e6; }
.LineNr { color: #585858; }
-->
</style>

<script>
<!--

/* function to open any folds containing a jumped-to line before jumping to it */
function JumpToLine()
{
  var lineNum;
  lineNum = window.location.hash;
  lineNum = lineNum.substr(1); /* strip off '#' */

  if (lineNum.indexOf('L') == -1) {
    lineNum = 'L'+lineNum;
  }
  var lineElem = document.getElementById(lineNum);
  /* Always jump to new location even if the line was hidden inside a fold, or
   * we corrected the raw number to a line ID.
   */
  if (lineElem) {
    lineElem.scrollIntoView(true);
  }
  return true;
}
if ('onhashchange' in window) {
  window.onhashchange = JumpToLine;
}

-->
</script>
</head>
<body onload='JumpToLine();'>
<pre id='vimCodeElement'>
<span id="L1" class="LineNr"> 1 </span>06/01/78 PL/I decimal data and the command hunt_dec.
<span id="L2" class="LineNr"> 2 </span>
<span id="L3" class="LineNr"> 3 </span>The command hunt_dec is a tool to aid the user when the new
<span id="L4" class="LineNr"> 4 </span>PL/I compiler implementing packed decimal is made available.
<span id="L5" class="LineNr"> 5 </span>This will be an incompatible change because the layout of
<span id="L6" class="LineNr"> 6 </span>variables containg both the unaligned and decimal attributes will
<span id="L7" class="LineNr"> 7 </span>be changed.  Therefore, it is necessary for the user to find
<span id="L8" class="LineNr"> 8 </span>those PL/I programs which currently use &quot;unaligned decimal&quot; so
<span id="L9" class="LineNr"> 9 </span>that the appropriate program and data base changes can be mode
<span id="L10" class="LineNr">10 </span>before recompiling the program using the new compiler.
<span id="L11" class="LineNr">11 </span>
<span id="L12" class="LineNr">12 </span>
<span id="L13" class="LineNr">13 </span>Classification algorithm:
<span id="L14" class="LineNr">14 </span>The algorithm hunt_dec uses to classify PL/I object segments
<span id="L15" class="LineNr">15 </span>is simple.  The text section is scanned for EIS decimal
<span id="L16" class="LineNr">16 </span>arithmetic instructions generated by the PL/I compiler.  If none
<span id="L17" class="LineNr">17 </span>are found the object segment is classified as &quot;no decimal&quot;.  If
<span id="L18" class="LineNr">18 </span>decimal instructions are found, they and their descriptors are
<span id="L19" class="LineNr">19 </span>examined for address modification and nonzero digit offsets.  If
<span id="L20" class="LineNr">20 </span>either is present, the object segment is classified as &quot;decimal
<span id="L21" class="LineNr">21 </span>unaligned&quot;, otherwise it is classified as &quot;decimal aligned&quot;.
<span id="L22" class="LineNr">22 </span>
<span id="L23" class="LineNr">23 </span>
<span id="L24" class="LineNr">24 </span>Validity of classification:
<span id="L25" class="LineNr">25 </span>The validity of the classification algorithm rests upon
<span id="L26" class="LineNr">26 </span>knowledge of how the PL/I compiler generates machine code.  Below
<span id="L27" class="LineNr">27 </span>is a table listing the reliability of the algorithm for the
<span id="L28" class="LineNr">28 </span>different classifications.
<span id="L29" class="LineNr">29 </span>
<span id="L30" class="LineNr">30 </span>
<span id="L31" class="LineNr">31 </span>CLASSIFICATION                RELIABILITY
<span id="L32" class="LineNr">32 </span>
<span id="L33" class="LineNr">33 </span>unaligned decimal             Always correct.
<span id="L34" class="LineNr">34 </span>
<span id="L35" class="LineNr">35 </span>aligned decimal               Fails when an unaligned decimal
<span id="L36" class="LineNr">36 </span>                              variable happens to falls on a word
<span id="L37" class="LineNr">37 </span>                              boundary.  For example,
<span id="L38" class="LineNr">38 </span>                                   dcl 1 record aligned,
<span id="L39" class="LineNr">39 </span>                                        2 item1 fixed bin<span class="textRainbow_lv0_p0">(</span>17<span class="textRainbow_lv0_p0">)</span>,
<span id="L40" class="LineNr">40 </span>                                        2 item2 fixed dec<span class="textRainbow_lv0_p0">(</span>3<span class="textRainbow_lv0_p0">)</span>
<span id="L41" class="LineNr">41 </span>                                        unaligned;   .
<span id="L42" class="LineNr">42 </span>                              The variable, item2, is unaligned
<span id="L43" class="LineNr">43 </span>                              decimal.  But, since it is located
<span id="L44" class="LineNr">44 </span>                              one word from the beginning of the
<span id="L45" class="LineNr">45 </span>                              structure the instruction accessing
<span id="L46" class="LineNr">46 </span>                              it appears to be accessing ALIGNED
<span id="L47" class="LineNr">47 </span>                              decimal data.
<span id="L48" class="LineNr">48 </span>
<span id="L49" class="LineNr">49 </span>no decimal                    If fixed decimal variables are
<span id="L50" class="LineNr">50 </span>                              present in the source program but
<span id="L51" class="LineNr">51 </span>                              are never referenced or do not have
<span id="L52" class="LineNr">52 </span>                              the initial attribute, no EIS fixed
<span id="L53" class="LineNr">53 </span>                              decimal instructions are generated
<span id="L54" class="LineNr">54 </span>                              by the compiler.
<span id="L55" class="LineNr">55 </span>
<span id="L56" class="LineNr">56 </span>     The important point to be made is that the hunt_dec command
<span id="L57" class="LineNr">57 </span>will correctly identify PL/I object segments that use unaligned
<span id="L58" class="LineNr">58 </span>decimal data most of the time while letting a few segments slip
<span id="L59" class="LineNr">59 </span>by misclassified as aligned decimal or no decimal.
</pre>
<script defer src='https://static.cloudflareinsights.com/beacon.min.js' data-cf-beacon='{"token": "4b6a131644014aa29fd88953508c3a3d"}'></script></body>
</html>
<!-- vim: set foldmethod=manual : -->
